#ifndef _CONFIG_H
#define _CONFIG_H

/*
 * Here you can find some parameters to tune; they are used by
 * the pseudo-heuristic scan of i-nodes and superblock. Adjust
 * the parameters to fit your filesystem.
 */


/*** i-node parameters ***********************/

 /* only i-nodes with the access, creation and modification times
    in given intervals will be considered as valid ones */

	/* access time */
#define ATIME_MIN	631148400	/* 1 Jan 1990 */
#define ATIME_MAX	(NOW+31536000)	/* 1 year from now */

	/* creation time */
#define CTIME_MIN	631148400	/* 1 Jan 1990 */
#define CTIME_MAX	(NOW+31536000)	/* 1 year from now */

	/* modification time */
#define MTIME_MIN	631148400	/* 1 Jan 1990 */
#define MTIME_MAX	(NOW+31536000)	/* 1 year from now */

 /* only i-nodes with UIDs and GIDs from the following ranges will
    be considered valid; terminate the list of intervals with
    interval {-1, -1}. */

#define UID_LIST	{{0,2047}, {32760,32767},	{-1,-1}}
#define GID_LIST	{{0,2047}, {32760,32767},	{-1,-1}}

 /* maximum "valid" file size */
#define FILE_SIZE_MAX	400000000l

 /* maximum links count. for normal files, this will be 1. for
    directories, this will be number_of_subdirectories+2. set this
    as low as possible, but not very low, or you will lose some
    directories */
#define LINKS_COUNT_MAX	40

/*** superblock parameters **********************/

 /* modification time of the superblock. */
#define SUPER_MTIME_MIN	631148400       /* 1 Jan 1990 */
#define SUPER_MTIME_MAX	(NOW+31536000)	/* 1 year from now */

 /* which operating system has created/used the superblock? */
#define SUPER_CREATOR_OS	0	/* EXT2_OS_LINUX from /usr/include/linux/ext2_fs.h */

/*** configuration check **********************/

 /* set this parameter to 1 */
#define I_CHECKED_CONFIG 1

#endif
