#ifndef _MAIN_H
#define _MAIN_H

#include <linux/fs.h>
#include <sys/types.h>

extern unsigned long blocksize;
extern unsigned long nr_blocks;
extern unsigned long long fs_size;
extern int groups;
extern int inodes_per_group;
extern int blocks_per_inodetable;
extern unsigned long nr_inodes;

extern struct ext2_super_block superblock;
extern struct ext2_group_desc *group_desc_block;

extern time_t NOW;

int find_super( int fd, long block, unsigned long bs);
int dirent_add(char * block, __u32 inum, char * name);
int dirent_del(char * block, __u32 inum, __u32 lost_found_ino);

void progressbar_init(char * text);
void progressbar_display(float percent, int opt);
void progressbar_stop(void);
int yesno(char * prompt);


#endif
