#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>

#include "main.h"
#include "disk.h"
#include "config.h"

int write_block( int fd, __u32 block, char *data )
{
	if( lseek(fd,block*blocksize,SEEK_SET)<0 )
	{	fprintf(stderr,"Write Error: Can't seek\n");
		return(0);
	}
	if( write(fd,data,blocksize)!=blocksize )
	{	fprintf(stderr,"Write Error!\n");
		return(0);
	}
	return(1);
}

int write_dirs( int fd )
{ struct mem_dir_s *d;
	for(d=mem_dirs;d!=NULL;d=d->next)
		if( d->need_to_write && d->to_block>0 )
			write_block(fd,d->to_block,&(d->data[0]));
	return(1);
}

